/* This file is autogenerated by scripts/decodetree.py.  */

typedef struct {
} arg_decode_msa322;

typedef struct {
    int df;
    int s16;
    int wt;
} arg_msa_bz;

typedef struct {
    int rd;
    int rs;
    int rt;
    int sa;
} arg_rtype;

typedef arg_rtype arg_LSA;
static bool trans_LSA(DisasContext *ctx, arg_LSA *a);
typedef arg_msa_bz arg_BZ_V;
static bool trans_BZ_V(DisasContext *ctx, arg_BZ_V *a);
typedef arg_msa_bz arg_BNZ_V;
static bool trans_BNZ_V(DisasContext *ctx, arg_BNZ_V *a);
typedef arg_msa_bz arg_BZ_x;
static bool trans_BZ_x(DisasContext *ctx, arg_BZ_x *a);
typedef arg_msa_bz arg_BNZ_x;
static bool trans_BNZ_x(DisasContext *ctx, arg_BNZ_x *a);
typedef arg_decode_msa322 arg_MSA;
static bool trans_MSA(DisasContext *ctx, arg_MSA *a);

static void decode_msa32_extract_bz(DisasContext *ctx, arg_msa_bz *a, uint32_t insn)
{
    a->wt = extract32(insn, 16, 5);
    a->s16 = extract32(insn, 0, 16);
    a->df = 3;
}

static void decode_msa32_extract_bz_df(DisasContext *ctx, arg_msa_bz *a, uint32_t insn)
{
    a->df = extract32(insn, 21, 2);
    a->wt = extract32(insn, 16, 5);
    a->s16 = extract32(insn, 0, 16);
}

static void decode_msa32_extract_decode_msa32_Fmt_3(DisasContext *ctx, arg_decode_msa322 *a, uint32_t insn)
{
}

static void decode_msa32_extract_lsa(DisasContext *ctx, arg_rtype *a, uint32_t insn)
{
    a->rs = extract32(insn, 21, 5);
    a->rt = extract32(insn, 16, 5);
    a->rd = extract32(insn, 11, 5);
    a->sa = extract32(insn, 6, 2);
}

static bool decode_msa32(DisasContext *ctx, uint32_t insn)
{
    union {
        arg_decode_msa322 f_decode_msa322;
        arg_msa_bz f_msa_bz;
        arg_rtype f_rtype;
    } u;

    switch ((insn >> 26) & 0x3f) {
    case 0x0:
        /* 000000.. ........ ........ ........ */
        decode_msa32_extract_lsa(ctx, &u.f_rtype, insn);
        switch (insn & 0x0000073f) {
        case 0x00000005:
            /* 000000.. ........ .....000 ..000101 */
            /* ../target/mips/msa32.decode:21 */
            if (trans_LSA(ctx, &u.f_rtype)) return true;
            break;
        }
        break;
    case 0x11:
        /* 010001.. ........ ........ ........ */
        switch ((insn >> 23) & 0x7) {
        case 0x2:
            /* 01000101 0....... ........ ........ */
            decode_msa32_extract_bz(ctx, &u.f_msa_bz, insn);
            switch ((insn >> 21) & 0x3) {
            case 0x3:
                /* 01000101 011..... ........ ........ */
                /* ../target/mips/msa32.decode:23 */
                if (trans_BZ_V(ctx, &u.f_msa_bz)) return true;
                break;
            }
            break;
        case 0x3:
            /* 01000101 1....... ........ ........ */
            decode_msa32_extract_bz(ctx, &u.f_msa_bz, insn);
            switch ((insn >> 21) & 0x3) {
            case 0x3:
                /* 01000101 111..... ........ ........ */
                /* ../target/mips/msa32.decode:24 */
                if (trans_BNZ_V(ctx, &u.f_msa_bz)) return true;
                break;
            }
            break;
        case 0x6:
            /* 01000111 0....... ........ ........ */
            /* ../target/mips/msa32.decode:26 */
            decode_msa32_extract_bz_df(ctx, &u.f_msa_bz, insn);
            if (trans_BZ_x(ctx, &u.f_msa_bz)) return true;
            break;
        case 0x7:
            /* 01000111 1....... ........ ........ */
            /* ../target/mips/msa32.decode:27 */
            decode_msa32_extract_bz_df(ctx, &u.f_msa_bz, insn);
            if (trans_BNZ_x(ctx, &u.f_msa_bz)) return true;
            break;
        }
        break;
    case 0x1e:
        /* 011110.. ........ ........ ........ */
        /* ../target/mips/msa32.decode:29 */
        decode_msa32_extract_decode_msa32_Fmt_3(ctx, &u.f_decode_msa322, insn);
        if (trans_MSA(ctx, &u.f_decode_msa322)) return true;
        break;
    }
    return false;
}
