/* This file is autogenerated by scripts/decodetree.py.  */

typedef struct {
    int rd;
    int rs;
    int rt;
    int sa;
} arg_rtype;

typedef arg_rtype arg_MFHI1;
static bool trans_MFHI1(DisasContext *ctx, arg_MFHI1 *a);
typedef arg_rtype arg_MTHI1;
static bool trans_MTHI1(DisasContext *ctx, arg_MTHI1 *a);
typedef arg_rtype arg_MFLO1;
static bool trans_MFLO1(DisasContext *ctx, arg_MFLO1 *a);
typedef arg_rtype arg_MTLO1;
static bool trans_MTLO1(DisasContext *ctx, arg_MTLO1 *a);
typedef arg_rtype arg_PCPYLD;
static bool trans_PCPYLD(DisasContext *ctx, arg_PCPYLD *a);
typedef arg_rtype arg_PCPYUD;
static bool trans_PCPYUD(DisasContext *ctx, arg_PCPYUD *a);
typedef arg_rtype arg_PCPYH;
static bool trans_PCPYH(DisasContext *ctx, arg_PCPYH *a);

static void decode_tx79_extract_rd(DisasContext *ctx, arg_rtype *a, uint32_t insn)
{
    a->rd = extract32(insn, 11, 5);
    a->rs = 0;
    a->rt = 0;
    a->sa = 0;
}

static void decode_tx79_extract_rs(DisasContext *ctx, arg_rtype *a, uint32_t insn)
{
    a->rs = extract32(insn, 21, 5);
    a->rt = 0;
    a->rd = 0;
    a->sa = 0;
}

static void decode_tx79_extract_rs_rt_rd(DisasContext *ctx, arg_rtype *a, uint32_t insn)
{
    a->rs = extract32(insn, 21, 5);
    a->rt = extract32(insn, 16, 5);
    a->rd = extract32(insn, 11, 5);
    a->sa = 0;
}

static void decode_tx79_extract_rt_rd(DisasContext *ctx, arg_rtype *a, uint32_t insn)
{
    a->rt = extract32(insn, 16, 5);
    a->rd = extract32(insn, 11, 5);
    a->rs = 0;
    a->sa = 0;
}

static bool decode_tx79(DisasContext *ctx, uint32_t insn)
{
    union {
        arg_rtype f_rtype;
    } u;

    switch (insn & 0xfc0007ff) {
    case 0x70000010:
        /* 011100.. ........ .....000 00010000 */
        decode_tx79_extract_rd(ctx, &u.f_rtype, insn);
        switch ((insn >> 16) & 0x3ff) {
        case 0x0:
            /* 01110000 00000000 .....000 00010000 */
            /* ../target/mips/tx79.decode:27 */
            if (trans_MFHI1(ctx, &u.f_rtype)) return true;
            break;
        }
        break;
    case 0x70000011:
        /* 011100.. ........ .....000 00010001 */
        decode_tx79_extract_rs(ctx, &u.f_rtype, insn);
        switch ((insn >> 11) & 0x3ff) {
        case 0x0:
            /* 011100.. ...00000 00000000 00010001 */
            /* ../target/mips/tx79.decode:28 */
            if (trans_MTHI1(ctx, &u.f_rtype)) return true;
            break;
        }
        break;
    case 0x70000012:
        /* 011100.. ........ .....000 00010010 */
        decode_tx79_extract_rd(ctx, &u.f_rtype, insn);
        switch ((insn >> 16) & 0x3ff) {
        case 0x0:
            /* 01110000 00000000 .....000 00010010 */
            /* ../target/mips/tx79.decode:29 */
            if (trans_MFLO1(ctx, &u.f_rtype)) return true;
            break;
        }
        break;
    case 0x70000013:
        /* 011100.. ........ .....000 00010011 */
        decode_tx79_extract_rs(ctx, &u.f_rtype, insn);
        switch ((insn >> 11) & 0x3ff) {
        case 0x0:
            /* 011100.. ...00000 00000000 00010011 */
            /* ../target/mips/tx79.decode:30 */
            if (trans_MTLO1(ctx, &u.f_rtype)) return true;
            break;
        }
        break;
    case 0x70000389:
        /* 011100.. ........ .....011 10001001 */
        /* ../target/mips/tx79.decode:34 */
        decode_tx79_extract_rs_rt_rd(ctx, &u.f_rtype, insn);
        if (trans_PCPYLD(ctx, &u.f_rtype)) return true;
        break;
    case 0x700003a9:
        /* 011100.. ........ .....011 10101001 */
        /* ../target/mips/tx79.decode:38 */
        decode_tx79_extract_rs_rt_rd(ctx, &u.f_rtype, insn);
        if (trans_PCPYUD(ctx, &u.f_rtype)) return true;
        break;
    case 0x700006e9:
        /* 011100.. ........ .....110 11101001 */
        decode_tx79_extract_rt_rd(ctx, &u.f_rtype, insn);
        switch ((insn >> 21) & 0x1f) {
        case 0x0:
            /* 01110000 000..... .....110 11101001 */
            /* ../target/mips/tx79.decode:39 */
            if (trans_PCPYH(ctx, &u.f_rtype)) return true;
            break;
        }
        break;
    }
    return false;
}
